# ory_oathkeeper_client
ORY Oathkeeper is a reverse proxy that checks the HTTP Authorization for validity against a set of rules. This service uses Hydra to validate access tokens and policies.

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.0.0-alpha.62
- Build package: org.openapitools.codegen.languages.DartClientCodegen
For more information, please visit [https://www.ory.am](https://www.ory.am)

## Requirements

Dart 2.0 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  ory_oathkeeper_client:
    git: https://github.com/ory/sdk.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  ory_oathkeeper_client:
    path: /path/to/ory_oathkeeper_client
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:ory_oathkeeper_client/api.dart';


final api_instance = ApiApi();

try {
    api_instance.decisions();
} catch (e) {
    print('Exception when calling ApiApi->decisions: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApiApi* | [**decisions**](doc//ApiApi.md#decisions) | **GET** /decisions | Access Control Decision API
*ApiApi* | [**getRule**](doc//ApiApi.md#getrule) | **GET** /rules/{id} | Retrieve a rule
*ApiApi* | [**getVersion**](doc//ApiApi.md#getversion) | **GET** /version | Get service version
*ApiApi* | [**getWellKnownJSONWebKeys**](doc//ApiApi.md#getwellknownjsonwebkeys) | **GET** /.well-known/jwks.json | Lists cryptographic keys
*ApiApi* | [**isInstanceAlive**](doc//ApiApi.md#isinstancealive) | **GET** /health/alive | Check alive status
*ApiApi* | [**isInstanceReady**](doc//ApiApi.md#isinstanceready) | **GET** /health/ready | Check readiness status
*ApiApi* | [**listRules**](doc//ApiApi.md#listrules) | **GET** /rules | List all rules


## Documentation For Models

 - [CreateRuleCreated](doc//CreateRuleCreated.md)
 - [CreateRuleForbidden](doc//CreateRuleForbidden.md)
 - [CreateRuleForbiddenBody](doc//CreateRuleForbiddenBody.md)
 - [CreateRuleInternalServerError](doc//CreateRuleInternalServerError.md)
 - [CreateRuleInternalServerErrorBody](doc//CreateRuleInternalServerErrorBody.md)
 - [CreateRuleUnauthorized](doc//CreateRuleUnauthorized.md)
 - [CreateRuleUnauthorizedBody](doc//CreateRuleUnauthorizedBody.md)
 - [DecisionsForbidden](doc//DecisionsForbidden.md)
 - [DecisionsForbiddenBody](doc//DecisionsForbiddenBody.md)
 - [DecisionsInternalServerError](doc//DecisionsInternalServerError.md)
 - [DecisionsInternalServerErrorBody](doc//DecisionsInternalServerErrorBody.md)
 - [DecisionsNotFound](doc//DecisionsNotFound.md)
 - [DecisionsNotFoundBody](doc//DecisionsNotFoundBody.md)
 - [DecisionsUnauthorized](doc//DecisionsUnauthorized.md)
 - [DecisionsUnauthorizedBody](doc//DecisionsUnauthorizedBody.md)
 - [DeleteRuleForbidden](doc//DeleteRuleForbidden.md)
 - [DeleteRuleForbiddenBody](doc//DeleteRuleForbiddenBody.md)
 - [DeleteRuleInternalServerError](doc//DeleteRuleInternalServerError.md)
 - [DeleteRuleInternalServerErrorBody](doc//DeleteRuleInternalServerErrorBody.md)
 - [DeleteRuleNotFound](doc//DeleteRuleNotFound.md)
 - [DeleteRuleNotFoundBody](doc//DeleteRuleNotFoundBody.md)
 - [DeleteRuleUnauthorized](doc//DeleteRuleUnauthorized.md)
 - [DeleteRuleUnauthorizedBody](doc//DeleteRuleUnauthorizedBody.md)
 - [GetRuleForbidden](doc//GetRuleForbidden.md)
 - [GetRuleForbiddenBody](doc//GetRuleForbiddenBody.md)
 - [GetRuleInternalServerError](doc//GetRuleInternalServerError.md)
 - [GetRuleInternalServerErrorBody](doc//GetRuleInternalServerErrorBody.md)
 - [GetRuleNotFound](doc//GetRuleNotFound.md)
 - [GetRuleNotFoundBody](doc//GetRuleNotFoundBody.md)
 - [GetRuleOK](doc//GetRuleOK.md)
 - [GetRuleUnauthorized](doc//GetRuleUnauthorized.md)
 - [GetRuleUnauthorizedBody](doc//GetRuleUnauthorizedBody.md)
 - [GetWellKnownForbidden](doc//GetWellKnownForbidden.md)
 - [GetWellKnownForbiddenBody](doc//GetWellKnownForbiddenBody.md)
 - [GetWellKnownJSONWebKeysInternalServerError](doc//GetWellKnownJSONWebKeysInternalServerError.md)
 - [GetWellKnownJSONWebKeysInternalServerErrorBody](doc//GetWellKnownJSONWebKeysInternalServerErrorBody.md)
 - [GetWellKnownJSONWebKeysOK](doc//GetWellKnownJSONWebKeysOK.md)
 - [GetWellKnownOK](doc//GetWellKnownOK.md)
 - [GetWellKnownUnauthorized](doc//GetWellKnownUnauthorized.md)
 - [GetWellKnownUnauthorizedBody](doc//GetWellKnownUnauthorizedBody.md)
 - [HealthNotReadyStatus](doc//HealthNotReadyStatus.md)
 - [HealthStatus](doc//HealthStatus.md)
 - [InlineResponse500](doc//InlineResponse500.md)
 - [IsInstanceAliveInternalServerError](doc//IsInstanceAliveInternalServerError.md)
 - [IsInstanceAliveInternalServerErrorBody](doc//IsInstanceAliveInternalServerErrorBody.md)
 - [IsInstanceAliveOK](doc//IsInstanceAliveOK.md)
 - [JsonWebKey](doc//JsonWebKey.md)
 - [JsonWebKeySet](doc//JsonWebKeySet.md)
 - [JudgeForbidden](doc//JudgeForbidden.md)
 - [JudgeForbiddenBody](doc//JudgeForbiddenBody.md)
 - [JudgeInternalServerError](doc//JudgeInternalServerError.md)
 - [JudgeInternalServerErrorBody](doc//JudgeInternalServerErrorBody.md)
 - [JudgeNotFound](doc//JudgeNotFound.md)
 - [JudgeNotFoundBody](doc//JudgeNotFoundBody.md)
 - [JudgeUnauthorized](doc//JudgeUnauthorized.md)
 - [JudgeUnauthorizedBody](doc//JudgeUnauthorizedBody.md)
 - [ListRulesForbidden](doc//ListRulesForbidden.md)
 - [ListRulesForbiddenBody](doc//ListRulesForbiddenBody.md)
 - [ListRulesInternalServerError](doc//ListRulesInternalServerError.md)
 - [ListRulesInternalServerErrorBody](doc//ListRulesInternalServerErrorBody.md)
 - [ListRulesOK](doc//ListRulesOK.md)
 - [ListRulesUnauthorized](doc//ListRulesUnauthorized.md)
 - [ListRulesUnauthorizedBody](doc//ListRulesUnauthorizedBody.md)
 - [Rule](doc//Rule.md)
 - [RuleHandler](doc//RuleHandler.md)
 - [RuleMatch](doc//RuleMatch.md)
 - [SwaggerCreateRuleParameters](doc//SwaggerCreateRuleParameters.md)
 - [SwaggerGetRuleParameters](doc//SwaggerGetRuleParameters.md)
 - [SwaggerHealthStatus](doc//SwaggerHealthStatus.md)
 - [SwaggerJSONWebKey](doc//SwaggerJSONWebKey.md)
 - [SwaggerJSONWebKeySet](doc//SwaggerJSONWebKeySet.md)
 - [SwaggerListRulesParameters](doc//SwaggerListRulesParameters.md)
 - [SwaggerNotReadyStatus](doc//SwaggerNotReadyStatus.md)
 - [SwaggerRule](doc//SwaggerRule.md)
 - [SwaggerRuleHandler](doc//SwaggerRuleHandler.md)
 - [SwaggerRuleMatch](doc//SwaggerRuleMatch.md)
 - [SwaggerRuleResponse](doc//SwaggerRuleResponse.md)
 - [SwaggerRulesResponse](doc//SwaggerRulesResponse.md)
 - [SwaggerUpdateRuleParameters](doc//SwaggerUpdateRuleParameters.md)
 - [SwaggerVersion](doc//SwaggerVersion.md)
 - [UpdateRuleForbidden](doc//UpdateRuleForbidden.md)
 - [UpdateRuleForbiddenBody](doc//UpdateRuleForbiddenBody.md)
 - [UpdateRuleInternalServerError](doc//UpdateRuleInternalServerError.md)
 - [UpdateRuleInternalServerErrorBody](doc//UpdateRuleInternalServerErrorBody.md)
 - [UpdateRuleNotFound](doc//UpdateRuleNotFound.md)
 - [UpdateRuleNotFoundBody](doc//UpdateRuleNotFoundBody.md)
 - [UpdateRuleOK](doc//UpdateRuleOK.md)
 - [UpdateRuleUnauthorized](doc//UpdateRuleUnauthorized.md)
 - [UpdateRuleUnauthorizedBody](doc//UpdateRuleUnauthorizedBody.md)
 - [Upstream](doc//Upstream.md)
 - [Version](doc//Version.md)


## Documentation For Authorization

 All endpoints do not require authorization.


## Author

hi@ory.am


